codeforces706C Hard problem 动态规划

来源:互联网 发布:林海 知乎 编辑:程序博客网 时间:2024/06/03 07:28

C. Hard problem
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy is fond of solving different tasks. Today he found one he wasn't able to solve himself, so he asks you to help.

Vasiliy is given n strings consisting of lowercase English letters. He wants them to be sorted in lexicographical order (as in the dictionary), but he is not allowed to swap any of them. The only operation he is allowed to do is to reverse any of them (first character becomes last, second becomes one before last and so on).

To reverse the i-th string Vasiliy has to spent ci units of energy. He is interested in the minimum amount of energy he has to spent in order to have strings sorted in lexicographical order.

String A is lexicographically smaller than string B if it is shorter than B (|A| < |B|) and is its prefix, or if none of them is a prefix of the other and at the first position where they differ character in A is smaller than the character in B.

For the purpose of this problem, two equal strings nearby do not break the condition of sequence being sorted lexicographically.

Input

The first line of the input contains a single integer n (2 ≤ n ≤ 100 000) — the number of strings.

The second line contains n integers ci (0 ≤ ci ≤ 109), the i-th of them is equal to the amount of energy Vasiliy has to spent in order to reverse the i-th string.

Then follow n lines, each containing a string consisting of lowercase English letters. The total length of these strings doesn't exceed100 000.

Output

If it is impossible to reverse some of the strings such that they will be located in lexicographical order, print  - 1. Otherwise, print the minimum total amount of energy Vasiliy has to spent.

Examples
input
21 2baac
output
1
input
31 3 1aabaac
output
1
input
25 5bbbaaa
output
-1
input
23 3aaaaa
output
-1
Note

In the second sample one has to reverse string 2 or string 3. To amount of energy required to reverse the string 3 is smaller.

In the third sample, both strings do not change after reverse and they go in the wrong order, so the answer is  - 1.

In the fourth sample, both strings consists of characters 'a' only, but in the sorted order string "aa" should go before string "aaa", thus the answer is  - 1.



题解来自:http://blog.csdn.net/zwj1452267376/article/details/52188231



题意:给出n个字符串(妈的是字符串啊,不是字符啊zz),可以颠倒任意一个字符串,颠倒每个字符串都有其对应的花费ci。经过操作后是否能满足字符串str[i]>=str[i-1],能输出最小花费,不能输出-1


注意:所有字符串加起来长度不超过100000,我看成每一个了,觉得怎么做都要炸


题解:因为不知道单个字符串具体长度,所以不能开字符串数组存储了(想了一下滚动数组,也可以)。这里string大法好啊。然后dp[i][0/1]表示第i个字符串是否颠倒(0表示不颠倒,1表示颠倒)的状态下满足字符串str[i]>=str[i-1]的最小花费。转态转移中判断各种使得str[i]>=str[i-1]的各种情况就可以了。


#include <cstdio>#include <cstring>#include <iostream>#include <cstdlib>#include <string>#include <algorithm>#define PAUSE system("pause")using namespace std;typedef long long ll;const int maxn = 100000;const ll INF = 1e15;string str[maxn + 5][2];ll dp[maxn + 5][2];int n, c[maxn + 5];string rev(string s) {string ts = s;int len = ts.length();for (int i = 0; i < len / 2; i++) {swap(ts[i], ts[len - i - 1]);}return ts;}int main(){cin >> n;for (int i = 0; i < n; i++) {scanf("%d", &c[i]);}for (int i = 0; i < n; i++) {string s;cin >> s;str[i][0] = s;str[i][1] = rev(s);//cout << str[i][0] << endl; //debug//cout << str[i][1] << endl;//PAUSE;}for (int i = 0; i < n; i++) {dp[i][0] = dp[i][1] = INF;}dp[0][0] = 0; dp[0][1] = c[0];int i;for (i = 1; i < n; i++) {if (str[i][0] >= str[i - 1][0])dp[i][0] = dp[i - 1][0];if (str[i][0] >= str[i - 1][1]) {dp[i][0] = min(dp[i][0], dp[i - 1][1]);}if (str[i][1] >= str[i - 1][0]) {dp[i][1] = dp[i - 1][0] + c[i];}if (str[i][1] >= str[i - 1][1]) {dp[i][1] = min(dp[i][1], dp[i - 1][1] + c[i]);}if (dp[i][0] == INF && dp[i][1] == INF) {break;}}if (i == n) {printf("%I64d\n", min(dp[n - 1][0], dp[n - 1][1]));}else {puts("-1");}return 0;}



0 0